import QtQuick 2.5
// import com.zuragon.Matlab 1.0
import com.zuragon.ViCANdo 1.0
import QtQuick.Controls 1.4

Rectangle {
    id: rectangle1
    width: 600
    height: 400
    color: "#e3d3a4"
    property int pendingCmdID : 0
    property real rpmValue : 0

    /*MathEngine {
        id: engine

        onOutput: {
            outputArea.text = output
        }

        onCommandDone: {
            // project.log("Command done: " + id + " pending " + pendingCmdID)
            if ( id === pendingCmdID ) {
                // project.log("*** Command done: " + id)
                video_result.image = engine.arrayToImage("adjusted_image");
                pendingCmdID = 0;
            }
        }
    }*/

    TextArea {
        id: commandArea
        height: 81
        anchors.right: parent.horizontalCenter
        anchors.rightMargin: 8
        anchors.left: parent.left
        anchors.leftMargin: 8
        anchors.top: label1.bottom
        anchors.topMargin: 8
    }

    TextArea {
        id: outputArea
        anchors.right: parent.horizontalCenter
        anchors.rightMargin: 0
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 8
        anchors.left: parent.left
        anchors.leftMargin: 8
        anchors.top: label2.bottom
        anchors.topMargin: 8
    }

    Button {
        id: evaluateButton
        x: 165
        text: qsTr("Evaluate")
        anchors.right: commandArea.right
        anchors.rightMargin: 0
        anchors.top: commandArea.bottom
        anchors.topMargin: 8

        onClicked: {
            var id = engine.evaluate(commandArea.text)
            console.log("Command id " + id)
        }

    }


    Label {
        id: label1
        color: "black"
        text: qsTr("Matlab command:")
        anchors.left: parent.left
        anchors.leftMargin: 8
        anchors.top: parent.top
        anchors.topMargin: 8
    }

    RPM {
        id: rpm_gauge
        rpm_value: rpmValue
        x: 371
        anchors.right: parent.right
        anchors.rightMargin: 8
        anchors.top: parent.top
        anchors.topMargin: 8
    }

    Label {
        id: label2
        x: 9
        y: 1
        color: "#000000"
        text: qsTr("Matlab result:")
        anchors.leftMargin: 9
        anchors.topMargin: 8
        anchors.top: evaluateButton.bottom
        anchors.left: parent.left
    }

    Label {
        id: label
        y: 240
        height: 17
        text: qsTr("RPM value:")
        anchors.verticalCenter: rpm_value_field.verticalCenter
        anchors.right: rpm_value_field.left
        anchors.rightMargin: 8
        anchors.left: rpm_formula_field.left
        anchors.leftMargin: 0
    }

    Label {
        id: label3
        y: 305
        height: 17
        text: qsTr("RPM Matlab processed:")
        anchors.verticalCenter: rpm_result_field.verticalCenter
        anchors.right: rpm_result_field.left
        anchors.rightMargin: 8
        anchors.left: rpm_formula_field.left
        anchors.leftMargin: 0
    }

    TextField {
        id: rpm_value_field
        x: 498
        width: 120
        height: 23
        text: rpmValue + " rpm"
        anchors.top: rpm_gauge.bottom
        anchors.topMargin: 19
        anchors.right: parent.right
        anchors.rightMargin: 8
        readOnly: true
    }

    TextField {
        id: rpm_formula_field
        height: 23
        anchors.left: outputArea.right
        anchors.leftMargin: 32
        anchors.top: rpm_value_field.bottom
        anchors.topMargin: 8
        anchors.right: parent.right
        anchors.rightMargin: 8
        placeholderText: qsTr("Text Field")
    }

    TextField {
        id: rpm_result_field
        x: 498
        width: 120
        height: 23
        text: "0"
        anchors.top: rpm_formula_field.bottom
        anchors.topMargin: 11
        anchors.right: parent.right
        anchors.rightMargin: 8
        readOnly: true
        placeholderText: qsTr("")
    }

    SourceEventListener {
        id: sel_rpm_s

        onDataReceived: {
            rpmValue = data.value
        }
    }

    Component.onCompleted: {
        console.log("App engine loaded")
        var fixed = project.findObject("fixed")
        if ( fixed === null ) {
            project.log("ERROR: there must be a fixed trace with name 'fixed'")
            return;
        }

        fixed.requestSlaveSource("rpm_s", "GPM13.EngineSpeed")
        sel_rpm_s.source              = project.findObject("rpm_s")
    }

}
